
var spurious_abstractor = {};  // Declare my namespace


spurious_abstractor._cachedPlatform = null;
spurious_abstractor._userAgent = null;



spurious_abstractor.supportsCopyButton = function() {



	if (spurious_abstractor.isIOS()) {
		return true;
	}

	if (spurious_abstractor.isAndroid()) {
		return true;
	}
	
	if (spurious_abstractor.isAIR()) {
		return true;
	}
	
	return false;


}


spurious_abstractor.copyToClipboard = function(text) {

	if (spurious_abstractor.isAIR()) {
		var copy = text;
 		air.Clipboard.generalClipboard.clear();
 		air.Clipboard.generalClipboard.setData(air.ClipboardFormats.TEXT_FORMAT, copy);
 		spurious_ui.updateStatusBar("Text copied to clipboard.");
 	}


	if (spurious_abstractor.isAndroid()) {
		Android.pushToClipboard(text);
	}

	if (spurious_abstractor.isIOS()) {
		text = btoa(text);
		spurious_ui.updateStatusBar("Text copied to clipboard.");
		spurious_ui.iPadBridge("copyToClipboard:",text);
		
	}


}

spurious_abstractor.exit = function() {


	

	if (spurious_abstractor.isPhoneGap()) {
		window.close();
	}
	
	if (spurious_abstractor.isAIR()) {
		spurious_abstractor.trace("Exit AIR style.");
		air.NativeApplication.nativeApplication.exit(0);
	}

}

spurious_abstractor.dateNowUTC = function() {

	var d = new Date();
	return d.toUTCString();
	
}

spurious_abstractor.importCSSIfPhoneGap = function() {

	if (spurious_abstractor.platform() == "phonegap") {
		spurious_common.importCSS("mobile.css");
	}

}

spurious_abstractor.importCSSIfTablet = function() {

	if (spurious_abstractor.isTablet() || spurious_abstractor.isCocoa()) {
		spurious_common.importCSS("mobile.css");
	}

}


spurious_abstractor.launchURL = function(url) {
	
	
	if (spurious_abstractor.isWebOS()) {
		window.open(url);
		return;
	}
	
	if (spurious_abstractor.isPhoneGap()) {
		
		window.plugins.childBrowser.showWebPage(url);
		
	} else if (spurious_abstractor.isDesktop()) {
		
		var urlReq = new air.URLRequest(url); 
		air.navigateToURL(urlReq);
		
	} else if (spurious_abstractor.isPlaybook()) { // Must be Playbook
		
		var args = new blackberry.invoke.BrowserArguments(url);
  		blackberry.invoke.invoke(blackberry.invoke.APP_BROWSER, args);
  	
	} else if (spurious_abstractor.isChrome()) {
		window.open(url);
	}
		
}

spurious_abstractor.canAutoSync = function() {

	if (spurious_abstractor.isCocoa() || spurious_abstractor.isAIR || spurious_abstractor.isChrome()) {
		spurious_abstractor.trace("Will be auto-syncing.");
		return true;
	}
	
	return false;
	
}
	
	
	
spurious_abstractor.isCocoa = function() {
		
		if (spurious_abstractor.platform() == "mac") {
	
			return true;
			
		}
		
		return false;
		
}

spurious_abstractor.isMac = function() {
		
		if (spurious_abstractor.platform() == "air") {
			if (air.NativeApplication.supportsMenu) {
				return true;
			}
		}
		
		return false;
		
}

spurious_abstractor.isDesktop = function() {
		
		if (spurious_abstractor.platform() == "air") {
				return true;
		}

		if (spurious_abstractor.isQT()) {
			return true;
		}
		
		return false;
		
}

spurious_abstractor.isTouchScreen = function() {
	
	if (spurious_abstractor.isPlaybook() || spurious_abstractor.isPhoneGap() || spurious_abstractor.isWebOS()) {
		return true;
	}
	
	return false;
	
}

spurious_abstractor.isTablet = function() {
	
	if (spurious_abstractor.isWebOS()) {
		return true;
	}

	if (spurious_abstractor.isQT()) {
			return true;
	}
	
	if (spurious_abstractor.isIOS()) {
			return true;
	}
	
	if (spurious_abstractor.isPlaybook() || spurious_abstractor.isPhoneGap() || spurious_abstractor.isChrome() || spurious_abstractor.isBlackBerry()) { // Chrome not a tablet, but near enough.
		
		return true;
	}
	
	return false;
	
}

spurious_abstractor.isChrome = function() {
	
		if (spurious_abstractor.platform() == "chrome") {
		return true;
	}

	return false;
	
	
}

spurious_abstractor.isPlaybook = function() {
	
	if (spurious_abstractor.platform() == "playbook") {
		return true;
	}

	return false;
	
	
}

spurious_abstractor.isAIR = function() {
	
	if (spurious_abstractor.platform() == "air") {
		return true;
	}

	return false;
	
	
}

spurious_abstractor.isQT = function() {


	

	if (spurious_abstractor.platform() == "qt") {
		return true;
	}

	return false;
}

spurious_abstractor.isPhoneGap = function() {
	
	if (spurious_abstractor.platform() == "phonegap") {
		return true;
	}

	return false;
	
	
}

spurious_abstractor.isIPhone = function() {
	
	if (spurious_common.stringContains(spurious_abstractor._userAgent,"iphone")) {
		return true;
	}

	return false;
	
	
}


spurious_abstractor.isIOS = function() {
	
	if (spurious_abstractor.platform() == "ios") {
		return true;
	}

	return false;
	
	
}

spurious_abstractor.isBlackBerry = function() {
	
	if (spurious_abstractor.platform() == "blackberry") {
		return true;
	}

	return false;
	
	
}


spurious_abstractor.isAndroid = function() {
		
		if (spurious_abstractor.platform() == "phonegap") {

			return true;
			
		}
		
		return false;
		
}


spurious_abstractor.isWebOS = function() {
		
		if (spurious_abstractor.platform() == "webos") {

			return true;
			
		}
		
		return false;
		
}




spurious_abstractor.platform = function() {

	

	if (spurious_abstractor._cachedPlatform != null) {
		//alert(spurious_abstractor._cachedPlatform);
		return spurious_abstractor._cachedPlatform;
	}

	var browser = navigator.userAgent.toLowerCase();
	spurious_abstractor._userAgent = browser;
	
	//console.log(browser);


/*
	if ( spurious_common.stringContains(browser,"linux")) {
		spurious_abstractor._cachedPlatform = "qt";
		return spurious_abstractor._cachedPlatform;
	}
*/

	if (spurious_common.stringContains(browser,"hpwos")) {
		spurious_abstractor._cachedPlatform = "webos";
		console.log("RUNNING ON WEBOS!!!");
		return spurious_abstractor._cachedPlatform;
	}

	if (spurious_common.stringContains(browser,"ipad") || spurious_common.stringContains(browser,"iphone")) {
		spurious_abstractor._cachedPlatform = "ios";
		return spurious_abstractor._cachedPlatform;
	}

	if (spurious_common.stringContains(browser,"adobeair")) {
		spurious_abstractor._cachedPlatform = "air";
		return spurious_abstractor._cachedPlatform;
	}


	if (spurious_common.stringContains(browser,"macintosh") && ! spurious_common.stringContains(browser,"chrome")) {
		spurious_abstractor._cachedPlatform = "mac";
		return spurious_abstractor._cachedPlatform;
	} else if (spurious_common.stringContains(browser,"playbook")) {
		spurious_abstractor._cachedPlatform = "playbook";
		return spurious_abstractor._cachedPlatform;
	} else if (spurious_common.stringContains(browser,"blackberry")) {
		spurious_abstractor._cachedPlatform = "blackberry";	
		return spurious_abstractor._cachedPlatform;
		
	} else if (spurious_common.stringContains(browser,"chrome")) {
		spurious_abstractor._cachedPlatform = "chrome";
		return spurious_abstractor._cachedPlatform;
	} else {
		spurious_abstractor._cachedPlatform = "phonegap";
		return spurious_abstractor._cachedPlatform;
	}
	
	return spurious_abstractor._cachedPlatform;
}

spurious_abstractor.trace = function(text) {

	//alert(text);
	//return;



	if (spurious_abstractor.isCocoa()) {
	
		spurious_ui.nymCocoa().log_(text);
		return;
		
	
	}
	


	if (spurious_abstractor.isQT()) {
		window.qml.log(text);
		return;
	}	

	if (spurious_abstractor.platform() == "air") {
		air.trace(spurious_abstractor._cachedPlatform+": "+text);
		return;
	}

	console.log(spurious_abstractor._cachedPlatform+": "+text);
	

}

spurious_abstractor.fileTail = function(path) {
	
	
	var bits = path.split(air.File.separator);
	return bits[bits.length - 1];
	
}


spurious_abstractor.fileWrite = function(filepath, data) {

	var fs = new air.FileStream();
	var file = new air.File(); 
	file.nativePath = filepath;
	fs.open(file, air.FileMode.WRITE);
	fs.writeUTF(data);
	fs.close();

}


spurious_abstractor.fileRead = function(file) {

        var fs = new air.FileStream();
        fs.open(file, air.FileMode.READ);
        var data = fs.readUTF();
        fs.close();
		return data;

}

function gtd_startup() {



}





