var spurious_prefs = {};  // Declare my namespace

spurious_prefs.WIDECATEGORYVIEW = "wide_category_view";
spurious_prefs.CUSTOMIZETEXTSIZE = "customize_text_size";
spurious_prefs.BREAKADDONTEXT = "break_addon_text";
spurious_prefs.SMALLMODE = "small_mode";
spurious_prefs.SERVICELOGINNAME = "sync_login_name";
spurious_prefs.SERVICELOGINPASSHASH = "sync_login_passhash";
spurious_prefs.SERVICETIMESTAMP = "sync_timestamp";
spurious_prefs.WINDOWX = "windowx";
spurious_prefs.WINDOWY = "windowy";
spurious_prefs.WINDOWW = "windoww";
spurious_prefs.WINDOWH = "windowh";

spurious_prefs.TASKVIEWHEADERSIZE = "taskviewheaderfontsize";
spurious_prefs.TASKITEMTITLESIZE = "taskitemtitlefontsize";
spurious_prefs.TASKITEMNOTESIZE = "taskitemnotefontsize";
spurious_prefs.CATEGORYLISTITEMSIZE = "categorylistitem_size";
spurious_prefs.CATEGORYLISTITEMADDONSIZE = "categorylistitemaddon_size";
spurious_prefs.FONTSMOOTHING = "font_smoothing";

spurious_prefs.supportsLocalStorage = function () {
	
	

	

	if (spurious_abstractor.isCocoa()) {
		return false;
	}
	
	try {
		var res =  'localStorage' in window && window['localStorage'] !== null;
		spurious_abstractor.trace("localstorage: "+res);
		return res;
	} catch(e){
		return false;
	}
	
}



spurious_prefs.allPrefsAsLookup = function() {


	var lookupout = {}

	lookupout["spurious_prefs.BREAKADDONTEXT"] = spurious_prefs.getPref(spurious_prefs.BREAKADDONTEXT,"");
	lookupout["spurious_prefs.SMALLMODE"] = spurious_prefs.getPref(spurious_prefs.SMALLMODE,"");
	lookupout["spurious_prefs.CUSTOMIZETEXTSIZE"] = spurious_prefs.getPref(spurious_prefs.CUSTOMIZETEXTSIZE,"");
	lookupout["spurious_prefs.WIDECATEGORYVIEW"] = spurious_prefs.getPref(spurious_prefs.WIDECATEGORYVIEW,"");
	lookupout["spurious_prefs.TASKVIEWHEADERSIZE"] = spurious_prefs.getPref(spurious_prefs.TASKVIEWHEADERSIZE,"");
	lookupout["spurious_prefs.TASKITEMTITLESIZE"] = spurious_prefs.getPref(spurious_prefs.TASKITEMTITLESIZE,"");
	lookupout["spurious_prefs.TASKITEMNOTESIZE"] = spurious_prefs.getPref(spurious_prefs.TASKITEMNOTESIZE,"");
	lookupout["spurious_prefs.CATEGORYLISTITEMSIZE"] = spurious_prefs.getPref(spurious_prefs.TASKITEMNOTESIZE,"");
	lookupout["spurious_prefs.CATEGORYLISTITEMADDONSIZE"] = spurious_prefs.getPref(spurious_prefs.TASKITEMNOTESIZE,"");
	lookupout["spurious_prefs.FONTSMOOTHING"] = spurious_prefs.getPref(spurious_prefs.FONTSMOOTHING,"");
	
	return lookupout;

}

spurious_prefs.factoryReset = function() {

	spurious_prefs.saveSyncTimeStamp("");
	spurious_prefs.savePassHash("");
	spurious_prefs.saveUsername("");

}

spurious_prefs.setWindowXYWH = function(x,y,w,h) {
	
	spurious_prefs.setPref(spurious_prefs.WINDOWX,x);
	spurious_prefs.setPref(spurious_prefs.WINDOWY,y);
	spurious_prefs.setPref(spurious_prefs.WINDOWW,w);
	spurious_prefs.setPref(spurious_prefs.WINDOWH,h);
	
	
}

spurious_prefs.windowX = function() {
	return spurious_prefs.getPref(spurious_prefs.WINDOWX,"-1");
}

spurious_prefs.windowY = function() {
	return spurious_prefs.getPref(spurious_prefs.WINDOWY,"-1");
}

spurious_prefs.windowW = function() {
	return spurious_prefs.getPref(spurious_prefs.WINDOWW,"-1");
}

spurious_prefs.windowH = function() {
	return spurious_prefs.getPref(spurious_prefs.WINDOWH,"-1");
}


spurious_prefs.syncTimeStamp = function() {
	return spurious_prefs.getPref(spurious_prefs.SERVICETIMESTAMP,"0");
}

spurious_prefs.saveSyncTimeStamp = function(n) {
	spurious_prefs.setPref(spurious_prefs.SERVICETIMESTAMP,n);
}

spurious_prefs.savePassHash = function(n) {
	spurious_prefs.setPref(spurious_prefs.SERVICELOGINPASSHASH,n);
}

spurious_prefs.saveUsername = function(n) {
	spurious_prefs.setPref(spurious_prefs.SERVICELOGINNAME,n);
}


spurious_prefs.passHash = function() {
	return spurious_prefs.getPref(spurious_prefs.SERVICELOGINPASSHASH,"");
}

spurious_prefs.username = function() {
	return spurious_prefs.getPref(spurious_prefs.SERVICELOGINNAME,"");
}

spurious_prefs.setPref = function(key,value) {

	if (spurious_abstractor.isCocoa()) {
		spurious_ui.nymCocoa().setPref_toValue_(key,value);
		return;
	}

	if (spurious_prefs.supportsLocalStorage()) {
		spurious_abstractor.trace("Setting pref the WebKit way");
		window.localStorage.setItem(key, value); 
	} else {
		spurious_abstractor.trace("Setting pref the AIR way");
		var bytes = new air.ByteArray();
		bytes.writeUTFBytes(value);
		air.EncryptedLocalStore.setItem(key, bytes);
	}

}


spurious_prefs.getPref = function(key_in,defaultval) {


	if (spurious_abstractor.isCocoa()) {
		return spurious_ui.nymCocoa().getPref_defaultValue_(key_in,defaultval);
		
	}

	if (spurious_prefs.supportsLocalStorage()) {
		spurious_abstractor.trace("Getting pref the WebKit way");
		testval = window.localStorage.getItem(key_in);
		spurious_abstractor.trace("TESTVAL FOR '"+key_in+"' : '"+testval+"'");
		if (testval == null) {
			spurious_abstractor.trace("Returning default val: '"+defaultval+"'");
			return defaultval;
		}
		spurious_abstractor.trace("Returning test val: '"+testval+"'");
		return testval;
		
	} else {
		spurious_abstractor.trace("Getting pref the AIR way");
		try {
			var storedValue = air.EncryptedLocalStore.getItem(key_in);
    			return storedValue.readUTFBytes(storedValue.length);
  		} catch (e) {
  			return defaultval;
  		}
	}

}


spurious_prefs.deletePref = function(key) {

	if (spurious_prefs.supportsLocalStorage()) {
		window['localStorage'].removeItem(key);
	} else {
		air.EncryptedLocalStore.removeItem(key);
	}

}
